#include "rtc.h"
#include "led.h"
#include "delay.h"
#include "usart.h" 
//////////////////////////////////////////////////////////////////////////////////	 
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com								  
//********************************************************************************
//޸˵
//V1.1 20140726
//:RTC_Get_Week,ڸϢ,õϢ.
////////////////////////////////////////////////////////////////////////////////// 

NVIC_InitTypeDef   NVIC_InitStructure;

//RTCʱ
//hour,min,sec:Сʱ,,
//ampm:@RTC_AM_PM_Definitions  :RTC_H12_AM/RTC_H12_PM
//ֵ:SUCEE(1),ɹ
//       ERROR(0),ʼģʽʧ 
ErrorStatus RTC_Set_Time(u8 hour,u8 min,u8 sec,u8 ampm)
{
	RTC_TimeTypeDef RTC_TimeTypeInitStructure;
	
	RTC_TimeTypeInitStructure.RTC_Hours=hour;
	RTC_TimeTypeInitStructure.RTC_Minutes=min;
	RTC_TimeTypeInitStructure.RTC_Seconds=sec;
	RTC_TimeTypeInitStructure.RTC_H12=ampm;
	
	return RTC_SetTime(RTC_Format_BIN,&RTC_TimeTypeInitStructure);
	
}
//RTC
//year,month,date:(0~99),(1~12),(0~31)
//week:(1~7,0,Ƿ!)
//ֵ:SUCEE(1),ɹ
//       ERROR(0),ʼģʽʧ 
ErrorStatus RTC_Set_Date(u8 year,u8 month,u8 date,u8 week)
{
	
	RTC_DateTypeDef RTC_DateTypeInitStructure;
	RTC_DateTypeInitStructure.RTC_Date=date;
	RTC_DateTypeInitStructure.RTC_Month=month;
	RTC_DateTypeInitStructure.RTC_WeekDay=week;
	RTC_DateTypeInitStructure.RTC_Year=year;
	return RTC_SetDate(RTC_Format_BIN,&RTC_DateTypeInitStructure);
}

//RTCʼ
//ֵ:0,ʼɹ;
//       1,LSEʧ;
//       2,ʼģʽʧ;
u8 My_RTC_Init(void)
{
	RTC_InitTypeDef RTC_InitStructure;
	u16 retry=0X1FFF; 
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);//ʹPWRʱ
	PWR_BackupAccessCmd(ENABLE);	//ʹܺ󱸼Ĵ 
	
	if(RTC_ReadBackupRegister(RTC_BKP_DR0)!=0x5050)		//Ƿһ?
	{
		RCC_LSEConfig(RCC_LSE_ON);//LSE     
		while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET)	//ָRCC־λ,ȴپ
			{
			retry++;
			delay_ms(10);
			}
		if(retry==0)return 1;		//LSE ʧ. 
			
		RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);		//RTCʱ(RTCCLK),ѡLSEΪRTCʱ    
		RCC_RTCCLKCmd(ENABLE);	//ʹRTCʱ 

    RTC_InitStructure.RTC_AsynchPrediv = 0x7F;//RTC첽Ƶϵ(1~0X7F)
    RTC_InitStructure.RTC_SynchPrediv  = 0xFF;//RTCͬƵϵ(0~7FFF)
    RTC_InitStructure.RTC_HourFormat   = RTC_HourFormat_24;//RTCΪ,24Сʱʽ
    RTC_Init(&RTC_InitStructure);
 
		RTC_Set_Time(23,59,56,RTC_H12_AM);	//ʱ
		RTC_Set_Date(14,5,5,6);		//
	 
		RTC_WriteBackupRegister(RTC_BKP_DR0,0x5050);	//Ѿʼ
	} 
 
	return 0;
}

//ʱ(,24Сʱ)
//week:ڼ(1~7) @ref  RTC_Alarm_Definitions
//hour,min,sec:Сʱ,,
void RTC_Set_AlarmA(u8 week,u8 hour,u8 min,u8 sec)
{ 
	EXTI_InitTypeDef   EXTI_InitStructure;
	RTC_AlarmTypeDef RTC_AlarmTypeInitStructure;
	RTC_TimeTypeDef RTC_TimeTypeInitStructure;
	
	RTC_AlarmCmd(RTC_Alarm_A,DISABLE);//رA 
	
  RTC_TimeTypeInitStructure.RTC_Hours=hour;//Сʱ
	RTC_TimeTypeInitStructure.RTC_Minutes=min;//
	RTC_TimeTypeInitStructure.RTC_Seconds=sec;//
	RTC_TimeTypeInitStructure.RTC_H12=RTC_H12_AM;
  
	RTC_AlarmTypeInitStructure.RTC_AlarmDateWeekDay=week;//
	RTC_AlarmTypeInitStructure.RTC_AlarmDateWeekDaySel=RTC_AlarmDateWeekDaySel_WeekDay;//
	RTC_AlarmTypeInitStructure.RTC_AlarmMask=RTC_AlarmMask_None;//ȷƥڣʱ
	RTC_AlarmTypeInitStructure.RTC_AlarmTime=RTC_TimeTypeInitStructure;
  RTC_SetAlarm(RTC_Format_BIN,RTC_Alarm_A,&RTC_AlarmTypeInitStructure);
 
	
	RTC_ClearITPendingBit(RTC_IT_ALRA);//RTCAı־
  EXTI_ClearITPendingBit(EXTI_Line17);//LINE17ϵжϱ־λ 
	
	RTC_ITConfig(RTC_IT_ALRA,ENABLE);//Aж
	RTC_AlarmCmd(RTC_Alarm_A,ENABLE);//A 
	
	EXTI_InitStructure.EXTI_Line = EXTI_Line17;//LINE17
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;//ж¼
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising; //ش 
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;//ʹLINE17
  EXTI_Init(&EXTI_InitStructure);//

	NVIC_InitStructure.NVIC_IRQChannel = RTC_Alarm_IRQn; 
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x02;//ռȼ1
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x02;//ȼ2
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;//ʹⲿжͨ
  NVIC_Init(&NVIC_InitStructure);//
}

//ԻѶʱ  
/*wksel:  @ref RTC_Wakeup_Timer_Definitions
#define RTC_WakeUpClock_RTCCLK_Div16        ((uint32_t)0x00000000)
#define RTC_WakeUpClock_RTCCLK_Div8         ((uint32_t)0x00000001)
#define RTC_WakeUpClock_RTCCLK_Div4         ((uint32_t)0x00000002)
#define RTC_WakeUpClock_RTCCLK_Div2         ((uint32_t)0x00000003)
#define RTC_WakeUpClock_CK_SPRE_16bits      ((uint32_t)0x00000004)
#define RTC_WakeUpClock_CK_SPRE_17bits      ((uint32_t)0x00000006)
*/
//cnt:Զװֵ.0,ж.
void RTC_Set_WakeUp(u32 wksel,u16 cnt)
{ 
	EXTI_InitTypeDef   EXTI_InitStructure;
	
	RTC_WakeUpCmd(DISABLE);//رWAKE UP
	
	RTC_WakeUpClockConfig(wksel);//ʱѡ
	
	RTC_SetWakeUpCounter(cnt);//WAKE UPԶװؼĴ
	
	
	RTC_ClearITPendingBit(RTC_IT_WUT); //RTC WAKE UPı־
  EXTI_ClearITPendingBit(EXTI_Line22);//LINE22ϵжϱ־λ 
	 
	RTC_ITConfig(RTC_IT_WUT,ENABLE);//WAKE UP ʱж
	RTC_WakeUpCmd( ENABLE);//WAKE UP ʱ
	
	EXTI_InitStructure.EXTI_Line = EXTI_Line22;//LINE22
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;//ж¼
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising; //ش 
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;//ʹLINE22
  EXTI_Init(&EXTI_InitStructure);//
 
 
	NVIC_InitStructure.NVIC_IRQChannel = RTC_WKUP_IRQn; 
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x02;//ռȼ1
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x02;//ȼ2
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;//ʹⲿжͨ
  NVIC_Init(&NVIC_InitStructure);//
}

//RTCжϷ
void RTC_Alarm_IRQHandler(void)
{    
	if(RTC_GetFlagStatus(RTC_FLAG_ALRAF)==SET)//ALARM Aж?
	{
		RTC_ClearFlag(RTC_FLAG_ALRAF);//жϱ־
		printf("ALARM A!\r\n");
	}   
	EXTI_ClearITPendingBit(EXTI_Line17);	//ж17жϱ־ 											 
}

//RTC WAKE UPжϷ
void RTC_WKUP_IRQHandler(void)
{    
	if(RTC_GetFlagStatus(RTC_FLAG_WUTF)==SET)//WK_UPж?
	{ 
		RTC_ClearFlag(RTC_FLAG_WUTF);	//жϱ־
		LED2=!LED2; 
	}   
	EXTI_ClearITPendingBit(EXTI_Line22);//ж22жϱ־ 								
}
 












